- [HTTP request](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.request_body)
  - [JSON representation](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.response_body)
  - [JSON representation](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.IngestUsersResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#body.aspect)
- [User](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#User)
  - [JSON representation](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#User.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#try-it)

Uploads a list of users to the provided destinations. Unlike `https://developers.google.com/data-manager/api/reference/rest/v1/audienceMembers/ingest#google.ads.datamanager.v1.IngestionService.IngestAudienceMembers` (which adds users to specific advertiser audience lists for targeting), `users.ingest` ingests account level identity linkage data (for example, user identifiers linked to mobile IDs) independent of specific audience segments.

This feature is only available to accounts on an allowlist.

### HTTP request

`POST https://datamanager.googleapis.com/v1/users:ingest`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "destinations": [ { object (`https://developers.google.com/data-manager/api/reference/rest/v1/Destination`) } ], "users": [ { object (`https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#User`) } ], "encryptionInfo": { object (`https://developers.google.com/data-manager/api/reference/rest/v1/EncryptionInfo`) }, "validateOnly": boolean, "encoding": enum (`https://developers.google.com/data-manager/api/reference/rest/v1/Encoding`) } ``` |

| Fields ||
|---|---|
| `destinations[]` | ``object (`https://developers.google.com/data-manager/api/reference/rest/v1/Destination`)`` Required. The list of possible ingestion destinations. |
| `users[]` | ``object (`https://developers.google.com/data-manager/api/reference/rest/v1/users/ingest#User`)`` Required. The list of users to ingest. |
| `encryptionInfo` | ``object (`https://developers.google.com/data-manager/api/reference/rest/v1/EncryptionInfo`)`` Optional. Encryption information about encryption keys which are used to encrypt the data. |
| `validateOnly` | `boolean` Optional. If `true`, the request is validated but not executed. |
| `encoding` | ``enum (`https://developers.google.com/data-manager/api/reference/rest/v1/Encoding`)`` Required. The encoding type of the user identifiers. For encrypted user identifiers, this only applies to the outer encoding. |

### Response body

Response from the IngestUsersRequest.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestId": string } ``` |

| Fields ||
|---|---|
| `requestId` | `string` The generated request id of the Ingestion Request. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/datamanager`

## User

Represents a single user, containing identifiers like PII and mobile device IDs that all refer to the same user.

| JSON representation |
|---|
| ``` { "userData": { object (`https://developers.google.com/data-manager/api/reference/rest/v1/UserData`) }, "mobileData": { object (`https://developers.google.com/data-manager/api/reference/rest/v1/MobileData`) } } ``` |

| Fields ||
|---|---|
| `userData` | ``object (`https://developers.google.com/data-manager/api/reference/rest/v1/UserData`)`` Required. Multiple pieces of user-provided data, used as the means of identifying the user. |
| `mobileData` | ``object (`https://developers.google.com/data-manager/api/reference/rest/v1/MobileData`)`` Required. Multiple mobile device ID strings to represent a single user. |